<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\TagService;

class TagController extends FMCrud{
    protected $TagService;
   
    public function __construct($crudService, $environment, TagService $TagService) {
        parent::__construct($crudService, $environment);
        $this->TagService = $TagService;
    }

    public function getTags(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $valores = $this->TagService->getTags($params);
        $dtsVal = new DataSet('tag', $valores);
        $response->addDataSet($dtsVal);
    }
}
?>