<?php

namespace FM\Service;

use FM\Factory\CategoriaManutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CategoriaManutService {

    protected $CategoriaManutFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, CategoriaManutFactory $CategoriaManutFactory, Environment $Environment, NewCode $newCode) {
        $this->CategoriaManutFactory = $CategoriaManutFactory;
        $this->connection            = $entityManager->getConnection();
        $this->Environment           = $Environment;
        $this->newCode               = $newCode;
    }

    public function insertNovaCategoriaManutencao($parametros) {
        $NRORG =  $this->Environment->getNrOrg();
        $this->connection->beginTransaction();

        try {

            $NRCATEGORIAMANUT = $this->newCode->getCodeByTableName("FCM_CATEGORIAMANUT", $NRORG, 1, 10, true);

            $parametrosCategoria = array(
                "NRCATEGORIAMANUT"  => $NRCATEGORIAMANUT,
                "NMCATEGORIAMANUT"  => $parametros['NMCATEGORIA'],
                "NMABREVCATEGMANUT" => $parametros['NMABREVIATURA'],
                "NRORG"             => $NRORG
            );

            $this->CategoriaManutFactory->insertNovaCategoriaManutencao($parametrosCategoria);

            forEach($parametros['TECNICOSREGISTRADOS'] as $Funcionario) {

                $NRFUNCCATEGORIAMANUT = $this->newCode->getCodeByTableName("FCM_FUNCCATEGORIAMANUT", $NRORG, 1, 10, true);

                $parametrosFuncionarios = array(
                    "NRFUNCCATEGORIAMANUT" => $NRFUNCCATEGORIAMANUT,
                    "NRCATEGORIAMANUT"     => $NRCATEGORIAMANUT,
                    "NRFUNCIONARIO"        => $Funcionario,
                    "NRORG"                => $NRORG
                );
                $this->CategoriaManutFactory->insertFuncionarioCategoriaManut($parametrosFuncionarios);
            }

            $this->connection->commit();
            $response = 'OK';

      } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }

    public function getInformacoesCategoriaManut() {

        $infoCategoria = $this->CategoriaManutFactory->getInformacoesCategoriaManut();
        return $infoCategoria;
    }

    public function getFuncionarioCategoriaManut() {

        $funcionarios = $this->CategoriaManutFactory->getFuncionarioCategoriaManut();
        return $funcionarios;
    }
}

?>