<?php

namespace FM\Service;

use FM\Factory\FotoTarefaGerChkFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Traits\TFileUpload;

class FotoTarefaGerChkService {
    
    use TFileUpload;

    protected $FotoTarefaGerChkFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (FotoTarefaGerChkFactory $FotoTarefaGerChkFactory, Environment $Environment, NewCode $newCode) {
        $this->FotoTarefaGerChkFactory = $FotoTarefaGerChkFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function anexarFoto($dados){
        $file = $this->uploadImages($dados['IMAGEM']);
        $NRORG = $this->Environment->getNrOrg();
        foreach($file as $image){
             $this->FotoTarefaGerChkFactory->salvarImagem(array(
                 'NRFOTOTAREFAGERCHK' => $this->newCode->getCodeByTableName("FCM_FOTOTAREFAGERCHK", $NRORG, 1, 10, true),
                 'NRTAREFAGERCHK' => intval($dados['NRTAREFA']),
                 'DSFOTOTAREFAGERCHK' => $image['DS'],
                 'NRORG' => $NRORG,
                 'CDOPERINCLUSAO' => $this->Environment->getCdOperador(),
                 'NRORGINCLUSAO' => $NRORG,
                 'CDOPERULTATU' => $this->Environment->getCdOperador(),
                 'NRORGULTATU' => $NRORG,
                 'DSTYPE' => $image['DSTYPE'],
                 'NRSIZE' => $image['QTSIZE']
             ));
        }
    }
    
    public function getFoto($dados){
        return $this->FotoTarefaGerChkFactory->getFoto(array(
            'NRTAREFAGERCHK' => $dados['NRTAREFA'],
        ));
    }
    
    public function getFotoTaskVistoria($dados){
        return $this->FotoTarefaGerChkFactory->getFotoTaskVistoria(array(
            'NRGERENCIAMENTOCHK' => $dados['NRTAREFA'],
        ));
    }
    
    public function deleteFoto($dados){
        return $this->FotoTarefaGerChkFactory->deleteFoto(array(
            'NRTAREFAGERCHK' => $dados['NRTAREFA'],
            'NRFOTOTAREFAGERCHK' => $dados['NRFOTOTAREFA'],
        ));
    }
}

?>