<?php
namespace FM\Service;

use FM\Factory\NewLocalFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class NewLocalService {
    
    protected $NewLocalFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (NewLocalFactory $NewLocalFactory, Environment $Environment, NewCode $newCode) {
        $this->NewLocalFactory  = $NewLocalFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getServiceCheckList(){
        $operadores = $this->NewLocalFactory->getFactoryCheckList();
        return $operadores;
    }
    
    public function insertServiceLocal($nmtipolocalcli, $idtipolocalcli, $idativo, $nrorg, $dstipolocalcli){
        
        $nrtipolocalcli = $this->newCode->getCodeByTableName('FCM_TIPOLOCALCLI', $this->Environment->getNrOrg(), 1, 10, true);
        
        $param = array(
            'NRTIPOLOCALCLI' => $nrtipolocalcli,
            'NMTIPOLOCALCLI' => $nmtipolocalcli, 
            'IDTIPOLOCALCLI' => $idtipolocalcli,
            'IDATIVO' => $idativo, 
            'NRORG' => $this->Environment->getNrOrg(), 
            'DSTIPOLOCALCLI' => $dstipolocalcli
        );
        
        try {
            $this->NewLocalFactory->insertFactoryLocal($param);
            $response = "Inserido com sucesso";
        }
        catch(\Exception $e) {
            $response = $e->getMessage();
        }
        return $response;
    }
    
    public function getControllerLocalToUpdate($nrtipolocalcli){
        $param = array(
            'NRTIPOLOCALCLI' => $nrtipolocalcli['nrtipolocalcli']
        );
        
        $operadores = $this->NewLocalFactory->getFactoryLocalToUpdate($param);
        return $operadores;
    }
    
    public function updateServiceLocal($nrtipolocalcli, $nmtipolocalcli, $idtipolocalcli, $dstipolocalcli){
        
        $param = array(
            'NRTIPOLOCALCLI' => $nrtipolocalcli,
            'NMTIPOLOCALCLI' => $nmtipolocalcli, 
            'IDTIPOLOCALCLI' => $idtipolocalcli,
            'DSTIPOLOCALCLI' => $dstipolocalcli
        );
        
        try {
            $this->NewLocalFactory->updateFactoryLocal($param);
            $response = "Alterado com sucesso";
        }
        catch(\Exception $e) {
            $response = $e->getMessage();
        }
        return $response;
    }
}
?>